#include "confalias.h"
#include "conftype.h"
#include "file.h"
struct virtualserverConf {
  //TODO: add error checking for adding alias to same directory
  char *diralias;
  char *cgipath;
  char *accesslog;
  char *email;
  char *host;
  char *dirindex;
  bool indexcgi;
  bool serversigniture;
  
  
  //Used if cloned
  bool islink;
  char *linkname; //name to structure pointed from
  }; 
struct serverConf {
  size_t Timeout;//0 for "connection: close"
  int unsigned short port;
  bool serversigniture;
  char *defaulttype;
  char *typemap;
  
  size_t numhosts;
  size_t maxrequestdata;
  size_t maxheaderdata;
  virtualserverConf *hosts;
  }; 
int isCgi(char *dirorfile, char * cgipath){
	char * strokcgitmp;
	char * pathpnt;
	pathpnt = strtok_r(cgipath, "*", &strokcgitmp);
	while(pathpnt != NULL){
		if(inPath(pathpnt, dirorfile) == AMATCH){
			return 1;
			}
		pathpnt = strtok_r(NULL, "*", &strokcgitmp);
		}
	return 0;
	}
void filecontenttype(char *file, char * typemap, char ** buf){
	char * stroktypetmp;
	char * ctypepnt;
	char * typepnt;
	fileext(file, &typepnt);
	if(typepnt == NULL){
		*buf = NULL;
		return;
		}
	ctypepnt = strtok_r(typemap, "*", &stroktypetmp);
	while(ctypepnt != NULL){ 
		if(strcmp(ctypepnt, typepnt) == 0){
			ctypepnt = strtok_r(NULL, "*", &stroktypetmp);
			racpy(&(*buf), ctypepnt);
			return;
			}
		ctypepnt = strtok_r(NULL, "*", &stroktypetmp);
		ctypepnt = strtok_r(NULL, "*", &stroktypetmp);
		}
	return;
	}
int AllocateServer(struct serverConf *serverconf, char * servername){
	serverconf->hosts = (virtualserverConf *)realloc(serverconf->hosts, ++serverconf->numhosts * sizeof(struct virtualserverConf));
	if(serverconf->hosts == NULL)
		return EMALLOC;
	memset(&serverconf->hosts[serverconf->numhosts - 1], 0, sizeof(struct virtualserverConf));
	
	serverconf->hosts[serverconf->numhosts - 1].host = (char *)malloc((strlen(servername) + 1) * sizeof(char));
	if(serverconf->hosts[serverconf->numhosts - 1].host == NULL)
		return EMALLOC;
	strcpy(serverconf->hosts[serverconf->numhosts - 1].host, servername);
		
	
	return 0;
	}

//return 0 on none, otherwise posistion (NOT a 0-X scale, 1-X)
size_t FindServer(struct serverConf *serverconf, char *servername){
	for(size_t hostc = 0 ; hostc < serverconf->numhosts ; hostc++){
		if(strcasecmp(servername, serverconf->hosts[hostc].host) == 0){
			if(serverconf->hosts[hostc].islink){ //check to see if this struct is really a symlink to something       
				return FindServer(serverconf, serverconf->hosts[hostc].linkname); //if yes, use linkname
				}
			return hostc + 1;
			}
		}
	return 0;
	}
	
//Will add another reference to a server by another name
int LinkServer(struct serverConf *serverconf, char * oldservername, char * newservername){
	
	
	if(strcasecmp("all", newservername) == 0){
		cout << "Warning: linking general purpose server to: " << oldservername << endl;
		size_t allservernum = FindServer(serverconf, newservername) - 1;
		serverconf->hosts[allservernum].islink = 1;
		racpy(&(serverconf->hosts[allservernum].linkname), oldservername);
		return 0;
		}
		
	//check to see if server we want to link to exists	
	if(FindServer(serverconf, oldservername) == 0){
		cout << oldservername << " is not a server!" << endl;
		return EOTHER;
		}
	//check to see if server we want to use as the link doesn't already exist	
	if(FindServer(serverconf, newservername) != 0){
		cout << newservername << " name is already taken!" << endl;
		return EOTHER;
		}
	int returnval = AllocateServer(serverconf, newservername);
	if(returnval)
		return returnval;
	size_t newservernum = FindServer(serverconf, newservername);
	if(newservernum == 0)
		return EOTHER;
	newservernum--;//must remember to do this, everything is num + 1, because no -1 for error, 0 is error
	
	
	
	serverconf->hosts[newservernum].islink = 1;
	racpy(&(serverconf->hosts[newservernum].linkname), oldservername);
	return 0;
	}
	
	
int setServerConf(struct serverConf * serverconf, char * server, char * command, char * setting1, char * setting2){
    struct virtualserverConf * thisServer;
    
    
    
    {
    size_t servernum = FindServer(&(*serverconf), server);
    if(servernum == 0){
    	//NEVER PASS IN A NON-ALLOCATED SERVER
    	return EOTHER;
	}
    thisServer = &serverconf->hosts[servernum - 1];
    }
    
    
    if(strcasecmp(command, "email") == 0){
	    racpy(&thisServer->email, setting1);
        }
    else if(strcasecmp(command, "accesslog") == 0){
	    racpy(&thisServer->accesslog, setting1);
	    }
    else if(strcasecmp(command, "dirindex") == 0){
	    racat(&thisServer->dirindex, setting1);
	    racat(&thisServer->dirindex, ",");
	    }
    else if(strcasecmp(command, "bindpath") == 0){
	    if(setting2 == NULL){
	    	cout << "Error: \"bindpath\" Must take two parameters\n";
	    	return 0;
	    	}
	    if(setting1[strlen(setting1) - 1] != '/' ||
	       setting2[strlen(setting2) - 1] != '/'){
	    	cout << "Error: \"bindpath\" requires all directories to end with a forward slash!\n";
		return 0;
		}
	    racat(&thisServer->diralias, setting1);
	    racat(&thisServer->diralias, "*");
	    racat(&thisServer->diralias, setting2);
	    racat(&thisServer->diralias, "*");
	    }
    else if(strcasecmp(command, "cgipath") == 0){
	    racat(&thisServer->cgipath, setting1);
	    racat(&thisServer->cgipath, "*");
	    }
     else if(strcasecmp(command, "indexcgi") == 0){
	    if(strcasecmp("on", setting1) == 0)
			thisServer->indexcgi = 1;
	    else if(strcasecmp("off", setting1) == 0)
		        thisServer->indexcgi = 0;
	    else
			cout << "Error: \"" << setting1 << "\" is invalid for \"indexcgi\"\n";
	    }
    return 0;
    }    
    
    
    
    
    
int setConfDefaults(struct serverConf * serverconf){
    serverconf->serversigniture = 1;
    serverconf->port = 80;
    serverconf->maxheaderdata = 1024;
    serverconf->maxrequestdata = 2048;
    racpy(&serverconf->defaulttype, "text/plain");
    AllocateServer(&(*serverconf), "all");
    return 0;
    }    
  
    
    
int LoadConf(char *file, struct serverConf *serverconf, bool setdefaults = 1){
	if(setdefaults){
		//zero out struct
		memset(&(*serverconf), 0, sizeof(struct serverConf));
		setConfDefaults(&(*serverconf));
		}
	ifstream configFile(file);
	if(configFile.fail()){
		cout << "Error: failed to open " << file << endl;
		return EFILE;
		}
	char * tokbuf;
	
	char * option;
	char * setting1;
	char * setting2;
	
	
	char * curserver = (char *)malloc(1024 * sizeof(char)); //good ol' 1 kilobyte
	if(curserver == NULL)
		return EMALLOC;
	curserver[0] = 0;
	
	
	char * buffer = (char *)malloc(1024 * sizeof(char));
	if(buffer == NULL)
		return EMALLOC;
		
	while(configFile.eof() == 0){
		configFile.getline(buffer, 1024);
		
		//tabs aren't the same as spaces, took a bit to figure out this one...;-)
		option = strtok_r(buffer, " \t", &tokbuf);
		if(option == NULL)
			continue;
		//if comment
		if(option[0] == '#')
			continue;
		
			
		if(tokbuf[0] == '\"')
			setting1 = strtok_r(NULL, "\"", &tokbuf);
		else
			setting1 = strtok_r(NULL, " \t\r\n", &tokbuf);
		if(setting1 == NULL)
			continue;
			
		//more shit left for stuff like bindpath
		if(tokbuf[0] != 0){
			//Skip to beginning of stuff, if last token was in quotes
			while(tokbuf[0] == ' ' || 
			      tokbuf[0] == '\t')
			      	*(tokbuf++);
				
				
			if(tokbuf[0] == '\"')
				setting2 = strtok_r(NULL, "\"", &tokbuf);
			else
				setting2 = strtok_r(NULL, " \t\r\n", &tokbuf);
			}
		else
			setting2 = NULL;
		
		
		//if empty line
		if(option[0] == '\r' ||
		   option[0] == '\n')
			continue;
		//New virtual server
		if(strcasecmp("server", option) == 0){
			strcpy(curserver, setting1);
			//If this server doesn't already exist
			if(FindServer(&(*serverconf), setting1) == 0){
				//if doesn't exist, create new server
				int returnval = AllocateServer(&(*serverconf), setting1);
				if(returnval){
					free(buffer);
					free(curserver);
					configFile.close();
					return returnval;
					}
				cout << "Adding server: " << setting1 << ". . ." << endl;
				}
// 			
			}
		//Global settings
		else if(strcasecmp("bind", option) == 0){
			serverconf->port = atoi(setting1);
			}
		else if(strcasecmp("link", option) == 0){
	    		if(setting2 == NULL){
	    			cout << "Error: \"link\" Must take two parameters\n";
	    			continue;
	    			}
			//TODO: error checking
			if(!LinkServer(&(*serverconf), setting1, setting2))
				cout << "New Alias Server: " << setting2 << " ---> " << setting1 << endl;
			
			}
		else if(strcasecmp("maxrequestdata", option) == 0){
			serverconf->maxrequestdata = atoi(setting1);
			}
		else if(strcasecmp("maxheaderdata", option) == 0){
			serverconf->maxheaderdata = atoi(setting1);
			}
		else if(strcasecmp("include", option) == 0){
			LoadConf(setting1, serverconf, 0);
			}
   		 else if(strcasecmp("bindtype", option) == 0){
	    		if(setting2 == NULL){
	    			cout << "Error: \"bindtype\" Must take two parameters\n";
	    			continue;
	    			}
	    		racat(&serverconf->typemap, setting1);
	    		racat(&serverconf->typemap, "*");
	    		racat(&serverconf->typemap, setting2);
	    		racat(&serverconf->typemap, "*");
	    		}
		else if(strcasecmp("serversigniture", option) == 0){
			if(strcasecmp("on", setting1) == 0)
				serverconf->serversigniture = 1;
			else if(strcasecmp("off", setting1) == 0)
				serverconf->serversigniture = 0;
			else
				cout << "Error: \"" << setting1 << "\" is invalid for \"serversigniture\"\n";
			}
		
		else if(strcasecmp("defaulttype", option) == 0){
			racpy(&(serverconf->defaulttype), setting1);
			}
			//Per-server settings handled here
		else{	
			setServerConf(&(*serverconf), curserver, option, setting1, setting2);
			}
			
			
			
		}
	free(curserver);
	free(buffer);
	configFile.close();
	return 0;
	}
