
int assesspathvalue(const char *path){
    char * strtokbuf;
    char * returnpnt;
    char * buffer = (char *)malloc( (strlen(path) + 1) * sizeof(char) );
    if(buffer == NULL)
	return EMALLOC;
    strcpy(buffer, path);

    size_t cntvalue = 0;
    returnpnt = strtok_r(buffer, "/\\", &strtokbuf);

    while(returnpnt != NULL){
        cntvalue++;
        returnpnt = strtok_r(NULL, "/\\", &strtokbuf);
        } 
    free(buffer);
    return cntvalue;
    }


//test example:  positive test for /cgi-bin/site1/program.cgi
//are  "/", "/cgi-bin/", and "/cgi-bin/site1/"
//TODO: what about trailing paths....?
int inPath(const char *base, const char *path){
    char * buffer = (char *)malloc( (strlen(path) + 1) * sizeof(char) );
    if(buffer == NULL)
	return EMALLOC;
    strcpy(buffer, path);
    
    size_t basestrlen = strlen(base);
    
    if(basestrlen > strlen(buffer)){
        free(buffer);
        return ESYNTAX; 
        } 
    buffer[basestrlen] = 0;	
    
    if(strcmp(buffer, base) == 0){
	free(buffer);
    	return AMATCH;
	}
    free(buffer);
    return 0;   
    }    

//will take in alias paths, and find out which on best fits the request,
//the buffer will be allocated, and the path copied to it
//This program will take in the alias format of "localdir*remotedir*anotherlocal*anotherremote"
//with an optional trailing "*"
int choosealiaspath(char **localbuf, char **remotebuf, char *aliases, char * path){
    size_t depthCount = 0;
    char * strtokbuf;
    char * dir;
    char * alias;
    dir = strtok_r(aliases, "*", &strtokbuf);
    alias = strtok_r(NULL, "*", &strtokbuf);
    
    while(dir != NULL && alias != NULL){
    	if(inPath(alias, path)  == AMATCH){
		size_t pathval = assesspathvalue(alias);
		if(pathval >= depthCount){
			depthCount = pathval;
			racpy(&(*localbuf), dir);
			racpy(&(*remotebuf), alias);
			}
		}
    	dir = strtok_r(NULL, "*", &strtokbuf);
    	alias = strtok_r(NULL, "*", &strtokbuf);
    	}
    
    return 0;
    }
//TODO: segfault lake waiting for a drowing victim.....
int dealiaspath(char **localpath, char *aliases, char * path){
    *localpath = NULL;
    char *aliasbuf = NULL;
    char *pathbuf = NULL;
    racpy(&aliasbuf, aliases);
    racpy(&pathbuf, path);
    
    char *local = NULL;
    char *remotealias = NULL;
    choosealiaspath(&local, &remotealias, aliasbuf, pathbuf);
    if(remotealias == NULL || local == NULL){
	return EOTHER;
	}
    char *cpypnt;
    {
    size_t remotealiaslen = strlen(remotealias);
    if(remotealiaslen > strlen(path)){
    	free(local);
    	free(remotealias);
        return ESYNTAX; 
        } 
  
    cpypnt = &path[remotealiaslen];
    }	
    racpy(&(*localpath), local);
    racat(&(*localpath), cpypnt);
    
    free(local);
    free(remotealias);
    return 0;
    }
    
    

