/* * * * * * * * * * * * * * * * * * * *
 * Karlan Mitchell (C) 2004            *
 * This source is LGPL                 *
 * * * * * * * * * * * * * * * * * * * */
 
/* * * * * * * * * * * * * * * * * * * *
 * dir.h:  Used to list files in any   *
 * given directory.  Built on top of   *
 * [mostly] dirent.h functions.        *
 * * * * * * * * * * * * * * * * * * * */
 
//TODO: Pass more things by address to keep the stack free
//TODO: FASTER, FASTER, FASTER! 

//This file is constanly being updated:
//Finally! The extreme slow downs have been kinked out!
//Known "bug":
//The count entries will not work 0 is passed for file and dir filter, get and
//find entries will.  This will not allow you to count anything but files
//and dirs.  But list and search for fifos, sockets, etc. TODO verfiy this!

//Define LIST_DOTDIRS to list . and ..

/*
I fixed an odd bug:
IsDir and IsFile were of NO use when compiled under MSVC or Borland, they worked fine under Mingw.
I changed their return value from size_t to bool, and they started working fine, WHY IS THIS?!
*/


/*Tested Platforms:
 *Windows with MinGW(GCC)
 *Windows with Cygwin(GCC)
 *Windows with Microsoft Visual C++ (with dirent.lib)
 *Windows with Borland C++
 *Linux with GCC
 *
 *Want to Try:
 *Linux with Borland (should work)
 *Windows/Linux with Intel C++ (might work)
 *Mac OS X with GCC (should work)
 *Mac OS 9 with Code Warrior (might not work)
 *
 *Will not work with:
 *Nothing I've found yet...
 *
 *BTW: I hate you, microsoft.
 */




#include <sys/stat.h>
#include <sys/types.h>
//You bastard, borland you
#ifdef __WIN32__
    #ifndef WIN32
    #define WIN32
    #endif
#endif

#ifdef _MSC_VER 
	#ifndef WIN32
		#define WIN32
	#endif 
    #pragma warning(disable: 4786)
	#pragma warning(disable: 4800)
    #include "windows/dirent.h"//Used because MSVC doesn't have one
    #include <io.h> //Used instead of unistd.h
    
    #define S_ISDIR(mode) (mode & _S_IFDIR)
    #define S_ISREG(mode) (mode & S_IFREG)
    #define access _access
    typedef int mode_t;
#elif __BORLANDC__
	#ifndef WIN32
		#define WIN32
	#endif 
    #include <dirent.h>
    #include <io.h>
#else
   #include <dirent.h>
   #include <unistd.h>
#endif

#ifndef NAME_MAX
//I don't know if this is ever variable, but MAX_PATH is
    #ifdef  MAX_NAME
        #define NAME_MAX MAX_NAME
    #else
        #define NAME_MAX 255
    #endif    
#endif
#ifndef PATH_MAX
    //Windows uses this
    #ifdef  MAX_PATH
        #define PATH_MAX MAX_PATH
    #else
        #define PATH_MAX 1024
    #endif
#endif
#ifdef WIN32
    #include <windows.h>
    #ifndef _MSC_VER
      #include <dirent.h>
    #endif
    #include "windows/fnmatch.h" //Again, the windows world lacks a good ol' POSIX or GNU library
   string PATHSLASH = "\\";
#else
    #include <fnmatch.h>
   string PATHSLASH = "/";
#endif



mode_t Attributes(string);
bool IsDir(string);
bool IsFile(string);


mode_t Attributes(string tFile){
		string mAttributeFile = tFile;
		struct stat mpStatBuf;
		stat(mAttributeFile.data(), &mpStatBuf);
		return mpStatBuf.st_mode;
		}
bool IsDir(string tDir){
		return ( S_ISDIR( Attributes(tDir) ) );
		}
bool IsFile(string tFile){
		return ( S_ISREG( Attributes(tFile) ) );
		}




class Directory {
   public:
      //Just open the current directory if none is specified
      Directory(string tDir){
            CD(tDir);
            }
      ~Directory(){
            }
      bool CD(string tDir){
            sDir = tDir;
            //This will add a slash to the end of the path, functions
            //don't work correctly otherwise
            if(sDir.at(sDir.size() - 1) != PATHSLASH.at(0)){
                        sDir.append(PATHSLASH);
                        }
            fdDirectory = opendir(sDir.data());
            if(fdDirectory != NULL)
                        return 1;
            else 
                        return 0;
            }
      string GetEntry(size_t tEntryNum, bool lsFiles = 1, bool lsDirs = 1){
            //I'm pretty sure that I NEED to call this, at least for what
            //I'm trying to do
            
            reset();
            struct dirent * DirEntry;
            for(size_t tEntryCounter = 0 ; ; tEntryCounter++){
			            DirEntry = readdir(fdDirectory);
			            
			            if(DirEntry == NULL){
			                    return "";
			                    }
                        if(lsFiles == 0){
                                if(IsFile( AddString(sDir, (DirEntry -> d_name)) ) == 1){
                                      tEntryCounter--;
                                      continue;
                                      }
                                }
                        if(lsDirs == 0){
                                if(IsDir( AddString(sDir, (DirEntry -> d_name)) ) == 1){
                                      tEntryCounter--;
                                      continue;
                                      }
                                }
                        #ifndef LIST_DOTDIRS
                        //Ignore this directory(.) and the the previous directory(..)
                        if(strcmp(DirEntry -> d_name, ".") == 0 || strcmp(DirEntry -> d_name, "..") == 0){
                               tEntryCounter--;
                               continue;
                               }
                        #endif
                        if(tEntryCounter == tEntryNum){
                            return DirEntry -> d_name;
                            }
                        }
               }
               
      string FindEntry(string EntryName, size_t tEntryNum, bool lsFiles = 1, bool lsDirs = 1){
             size_t PlaceCounter = 0;
             for(size_t tEntryCounter = 0 ; !GetEntry(tEntryCounter, lsFiles, lsDirs).empty() ; tEntryCounter++){
                          if(fnmatch(EntryName.data(),(GetEntry(tEntryCounter, lsFiles, lsDirs)).data(), 0) == 0){
                                 if(PlaceCounter != tEntryNum){
				                             PlaceCounter++;
                                             continue;
                                             }
                                 return GetEntry(tEntryCounter, lsFiles, lsDirs);
                                 }
                          }
             return "";
             }
             
             
             
      size_t CountwcEntries(string Pattern, bool lsFiles = 1, bool lsDirs = 1){
            if(lsFiles == 0 && lsDirs == 0){
                        return 0;
                        } 
            reset();
            struct dirent * DirEntry;
            size_t Counter = 0;
            while(1){
			            DirEntry = readdir(fdDirectory);
			            if(DirEntry == NULL)
			                           break;
                        if(lsFiles == 0){
                                if(IsFile(DirEntry -> d_name) == 1){
                                      continue;
                                      }
                                }
                        if(lsDirs == 0){
                                if(IsDir(DirEntry -> d_name) == 1){
                                      continue;
                                      }
                                }
                        if(fnmatch(Pattern.data(),DirEntry->d_name,0) == 0)
                                                Counter++;
			            }
            if(lsDirs == 1 && IsDir(sDir)){
                        Counter -= 2;
                        }
            return Counter;
            }
            
            
            
      size_t CountEntries(bool lsFiles = 1, bool lsDirs = 1){
            if(lsFiles == 0 && lsDirs == 0){
                        return 0;
                        } 
            reset();
            struct dirent * DirEntry;
            size_t tEntryCounter = 0;
            for( ; ; tEntryCounter++){
			            DirEntry = readdir(fdDirectory);
			            if(DirEntry == NULL)
			                           break;
                        if(lsFiles == 0){
                                if(IsFile( AddString(sDir, (DirEntry -> d_name)) ) == 1){
                                      tEntryCounter--;
                                      continue;
                                      }
                                }
                        if(lsDirs == 0){
                                if(IsDir( AddString(sDir, (DirEntry -> d_name)) ) == 1){
                                      tEntryCounter--;
                                      continue;
                                      }
                                }
			            }
            //If we are listing directories we have these two guys: ".", ".."
            //We can forget about them
            if(lsDirs == 1 && IsDir(sDir)){
                        tEntryCounter -= 2;
                        }
            return tEntryCounter;
            }
      string pwd(){
            return sDir;
            }
   protected:
      string sDir;
      DIR * fdDirectory;
   
      void reset(){
            closedir(fdDirectory);
            fdDirectory = opendir(sDir.data());
            }
  };
