/* * * * * * * * * * * * * * * * * * * *
 * Karlan Mitchell (C) 2004            *
 * This source is LGPL                 *
 * * * * * * * * * * * * * * * * * * * */
 
/* * * * * * * * * * * * * * * * * * * *
 * env.h:  Functions which modify      *
 * the program's envorinment, such as  *
 * changing the current working        *
 * directory.                          *
 * This is where most of the           *
 * cross-platform base is found        * 
 * NOTE: some POSIX functions for      *
 * windows will find their way here    *
 * setenv(), for example               *
 * * * * * * * * * * * * * * * * * * * */
 //TODO: These functions, env.h, need to be C-ified, NO C++ STL!
 
 
#include <stdlib.h>
#include "dir.h"

off_t getfilesize(char *filename)
{
    struct stat file;
     
     if(!stat(filename,&file)){
         return file.st_size;
     }
     return 0;
}

#ifdef WIN32
 string CWD(){
 	char buffer[PATH_MAX];
	buffer[0] = 0;
	GetCurrentDirectory(PATH_MAX, buffer);
	return buffer;
 	}
#else
string CWD(){
 	char buffer[PATH_MAX];
	getcwd(buffer, PATH_MAX);
	return buffer;
 	}
#endif

//The ONE time windows has a more simple function, and probaly faster.
bool setcwd(string Dir){
        if(strcmp(Dir.data(), ".") == 0){
        #ifdef WIN32
                   return SetCurrentDirectory((CWD()).data());
		#else
           	   if(chdir(Dir.data()) == 0)
	   	      return 1;
	           else
	   	      return 0;
		#endif
                }
    #ifdef WIN32
           return SetCurrentDirectory(Dir.data());
	#else
           if(chdir(Dir.data()) == 0)
	   	return 1;
	   else
	   	return 0;
	#endif
        }



#ifdef WIN32
/*
NAME
       setenv - change or add an environment variable

SYNOPSIS
       #include <stdlib.h>

       //DONE: ? int setenv(const char *name, const char *value, int overwrite);

       //TODO: void unsetenv(const char *name);

DESCRIPTION
       The  setenv() function adds the variable name to the envi-
       ronment with the value value, if  name  does  not  already
       exist.   If  name  does exist in the environment, then its
       value is changed to value if  overwrite  is  non-zero;  if
       overwrite  is zero, then the value of name is not changed.

       The unsetenv() function deletes the variable name from the
       environment.

RETURN VALUE
       The  setenv()  function  returns zero on success, or -1 if
       there was insufficient space in the environment.

CONFORMING TO
       BSD 4.3
 */
//AH I HATE YOU MICROSOFT
//This is used for all the below functions, but is not implemented in
//Microsoft Visual C++, .....really annoying, I hate this crap
//TODO: implement overwrite for setenv(MSVC)
int forcesetenv(const char *name, const char *value){
    char * variableCommand = (char *)malloc(strlen(name) + strlen(value) + 2);
    if(variableCommand == NULL)                                 //Something went wrong. . . 
        return -1;
    variableCommand[0] = 0;
    strncat(variableCommand, name, strlen(name));
    strncat(variableCommand, "=", 1);
    strncat(variableCommand, value, strlen(value));
    cout << variableCommand << endl;
    if(putenv(variableCommand)){
        free(variableCommand);                                  //Free taken space, clause 1
        return -1;
        }   
    free(variableCommand);                                    //Free taken space, clause 2
    return 0;
    }    
int setenv(const char *name, const char *value, int overwrite){
char * variableTest = getenv(name);
if(variableTest != NULL && overwrite != 0)                                    //Free taken space, clause 2
    return forcesetenv(name, value);    
else if(variableTest == NULL && overwrite == 0)
    return forcesetenv(name, value);
return -1;
}
#endif
