//Pass preallocated copy of ResponesData, ALL data must initialized, and zeroed if not using
#ifdef __sendfile__
#include <sys/sendfile.h>
#endif
#include <unistd.h>
#include "cgienv.h"

     
int SendHeader(int socketd, 
               char *protocol, 
	       char *code, 
	       char *word,
	       char *contenttype = NULL){
	int returnval = 0;       
	char * headerbuf = NULL;
	if(protocol == NULL)
	  racpy(&headerbuf, "HTTP/1.0");
	else
	  racpy(&headerbuf, protocol);
	racat(&headerbuf, " ");
	racat(&headerbuf, code);
	racat(&headerbuf, " ");
	racat(&headerbuf, word);
	racat(&headerbuf, "\x0D\x0A");
	racat(&headerbuf, "Connection: close\x0D\x0A");
	racat(&headerbuf, "Server: KHD/0.3\x0D\x0A");
	
	if(contenttype != NULL){
		racat(&headerbuf, "Content-Type: ");
		racat(&headerbuf, contenttype);
		racat(&headerbuf, "\x0D\x0A");
		}
	
	returnval = sendall(socketd, headerbuf, strlen(headerbuf));
	free(headerbuf);
	return returnval;
	}
	   
//No support for range!
int SendFile(int socketd, char *filename){
	int returnval;
	ifstream filetestsize (filename, ios::binary);
	filetestsize.seekg(0, ios::end);
	size_t fileSize = filetestsize.tellg();
	filetestsize.close();
	
	char * sendbuf = (char*)malloc(30 * sizeof(char));
	if(sendbuf == NULL)
		return EMALLOC;
	snprintf(sendbuf, 30, "Content-Length: %d\x0D\x0A\x0D\x0A", fileSize);
	sendall(socketd, sendbuf, strlen(sendbuf));
	free(sendbuf);
	sendbuf = NULL;
	
	
	#ifdef __sendfile__
	
	int filedescriptor = open(filename, O_RDONLY);
	if(filedescriptor == -1){
		cout << "FATAL fd error!?? Fix code karlan....\n";
		exit(0);
		}
	//TODO: sendfile modifies out_fd??!!!!!!!!!! check manpage
	returnval = sendfile(socketd,filedescriptor, 0, fileSize);
	//close(filedescriptor);
	if(returnval != -1){
		return 0;
		}
	#endif
	

	//exit(0);
	//TODO: tune up sendfile emulation
	FILE *fd;
	int c[2];
	c[1] = 0;

	fd = fopen(filename, "r"); 
	
	int bufcnt = 0;
	//sendbuf = (char*)malloc(2 *sizeof(char));
	off_t filesize = getfilesize(filename);
	for(off_t pos = 0 ; pos < filesize ; pos++){
		c[0] = fgetc(fd);
		send(socketd, c, 1,0);
		bufcnt++;
		}
		
	
	fclose(fd);
	free(sendbuf);
	
	
	
	return 0;
	}

	

int RespondError(int socketd, int short unsigned errorcode, struct RequestData * pRequestData, struct serverConf *serverconf, size_t thisServer, char * extra = NULL){  
	char * codebuf = (char *)malloc(5 * sizeof(char));
	snprintf(codebuf, 5, "%d", errorcode);
	
	char * errorwordbuf = NULL;
	
	switch(errorcode){
		case 301:
			racpy(&errorwordbuf, "Moved Permanently");
			break;
		case 400:
			racpy(&errorwordbuf, "Bad Request");
			break;
		case 401:
			racpy(&errorwordbuf, "Unauthorized");
			break;
		case 403:
			racpy(&errorwordbuf, "Forbidden");
			break;
		case 404:
			racpy(&errorwordbuf, "Not Found");
			break;
		case 405:
			racpy(&errorwordbuf, "Method Not Allowed");
			break;
		case 406:
			racpy(&errorwordbuf, "Not Acceptable");
			break;
		case 411:
			racpy(&errorwordbuf, "Length Required");
			break;
		case 412:
			racpy(&errorwordbuf, "Precondition Failed");
			break;
		case 413:
			racpy(&errorwordbuf, "Request Entity Too Large");
			break;
		case 414:
			racpy(&errorwordbuf, "Request-URI Too Long");
			break;
		case 415:
			racpy(&errorwordbuf, "Unsupported Media Type");
			break;
		case 416:
			racpy(&errorwordbuf, "Requested Range Not Satisfiable");
			break;
		case 417:
			racpy(&errorwordbuf, "Expectation Failed");
			break;
		case 500:
			racpy(&errorwordbuf, "Internal Server Error");
			break;
		case 501:
			racpy(&errorwordbuf, "Not Implemented");
			break;
		default:
			racpy(&errorwordbuf, "Unkown Error Code");
			break;
		}
	
	SendHeader(socketd, pRequestData->protocol, codebuf, errorwordbuf, "text/html");
	if(extra != NULL){
		sendall(socketd, extra, strlen(extra));
		}
	sendall(socketd, "\x0D\x0A<h1><b>", 2);
	sendall(socketd, errorwordbuf, strlen(errorwordbuf));
	sendall(socketd, "(", 1);
	sendall(socketd, codebuf, strlen(codebuf));
	sendall(socketd, ")</b></h1>", 1);
	free(errorwordbuf);
	free(codebuf);
	return 0;
	} 
	
		
int RespondCgi(int socketd, char *cgifile, struct RequestData * pRequestData, struct serverConf *serverconf, size_t thisServer){   
	
	setdcgi(pRequestData->host,             //server
	        "",  //port
	        pRequestData->method,
		pRequestData->url,   
		pRequestData->referer,
		"",
		pRequestData->accept,           //httpaccept
		pRequestData->useragent,       
		"",
		pRequestData->query);
	
	
	SendHeader(socketd, "HTTP/1.0", "200", "OK");
	//sendall(socketd, "Content-encoding: chunked\x0D\x0A", strlen("Content-encoding: chunked\x0D\x0A"));
  	signal(SIGCHLD, SIG_IGN);
        int stdoutpipe[2];
	pipe(stdoutpipe);
	if(!fork()){
			
		close(1);       /* close normal stdout */
		dup(stdoutpipe[1]);  
		close(stdoutpipe[0]);
		close(socketd);
		
		
		if(pRequestData->data != NULL){
			close(0);   
        		int stdinpipe[2];
			pipe(stdinpipe);
			dup(stdinpipe[0]); 
			TRACE(pRequestData->data);
			write(stdinpipe[1], (pRequestData->data), strlen(pRequestData->data));
			write(stdinpipe[1], "", 1);//send an end of file
			}
			
		execl(cgifile, NULL);
		exit(0);
		}
	close(stdoutpipe[1]);
	char c[2] = {0,0};
	char tc[2] = {0,0};
	int rv;
	int header = 2;
	while(1){
		
		rv =read(stdoutpipe[0], tc, 1);
		if(rv == -1 || rv == 0)
			break;	
		c[0] = tc[0];
		send(socketd, c, 1, 0);
		}
	return 0;
	}
int RespondFile(int socketd, char *filename, struct RequestData * pRequestData, struct serverConf *serverconf, size_t thisServer){
	char * contenttype = NULL;
	
	filecontenttype(filename, serverconf->typemap, &contenttype);
	if(contenttype == NULL)
		racat(&contenttype, serverconf->defaulttype);
     	int returnval;
	returnval = SendHeader(socketd, pRequestData->protocol, "200", "OK", contenttype);
	//if(returnval){
	//	free(contenttype);
	//	return returnval;
	//	}
	returnval = SendFile(socketd, filename);
	free(contenttype);	
	if(returnval)
		return returnval;
	return 0;
	}
int RespondDir(int socketd, char *dir, struct RequestData * pRequestData, struct serverConf *serverconf, size_t thisServer){
	if(pRequestData->url[strlen(pRequestData->url) - 1] != '/'){
		racat(&pRequestData->url, "/");
		}
	
	//Check for index file
	{
	char *indexbuf = NULL;
	char *strtokbuf;
	char *indexfile;
	indexfile = strtok_r(serverconf->hosts[thisServer].dirindex, ",", &strtokbuf);
	
	while(indexfile != NULL){
		racpy(&indexbuf, dir);
		racat(&indexbuf, indexfile);
		if(FileTest(indexbuf)){
			if(serverconf->hosts[thisServer].indexcgi == 1 &&
			   strcasecmp(indexfile, "index.cgi") == 0)//if indexcgi option is on, index.cgi file is cgi
				RespondCgi(socketd, indexbuf, pRequestData, serverconf, thisServer);
			else if(isCgi(indexbuf, serverconf->hosts[thisServer].cgipath))//if this directory is cgi dir, index file is cgi
				RespondCgi(socketd, indexbuf, pRequestData, serverconf, thisServer);
			else//display index
				RespondFile(socketd, indexbuf, pRequestData, serverconf, thisServer);
			free(indexbuf);
			return 0;
			}
		indexfile = strtok_r(NULL, ",", &strtokbuf);
		}
	
	free(indexbuf);
	}
	//cout << "TODO!!!!: Directory Index...\n";
	
	
	//return HE_FORBIDDEN;  //FOR NOW!
	
	
	SendHeader(socketd, pRequestData->protocol, "200", "OK", "text/html");
	
	DIR * lsdir = opendir(dir);
	struct  dirent * lsdirent;
	
	sendall(socketd, "\x0D\x0A", 2);
	sendall(socketd, "Temp Ghetto Directory Listing<br />\n", strlen("Temp Ghetto Directory Listing<br />\n"));
	while(1){
		lsdirent = readdir(lsdir);
		if(lsdirent == NULL)
			break;
		if(lsdirent->d_name[0] == '.')//hidden file
			continue;
		sendall(socketd, "<a href=\"", strlen("<a href=\""));
		sendall(socketd, pRequestData->url, strlen(pRequestData->url));
		sendall(socketd, lsdirent->d_name, strlen(lsdirent->d_name));
		sendall(socketd, "\">", strlen("\">"));
		sendall(socketd, lsdirent->d_name, strlen(lsdirent->d_name));
		sendall(socketd, "</a>", strlen("</a>"));
		sendall(socketd, "<br />\n", 6);
		}
	//lsbufferlen = strlen(lsbuffer);
	//char *numbuf = (char*)malloc(10 * sizeof(char));
	//snprintf(numbuf, 10, "%d", lsbufferlen);
//	
//	racat(&contentlength, numbuf);
//	free(numbuf);
	
//	racat(&contentlength, "\x0D\x0A");
//	
//	sendall(socketd, contentlength, strlen(contentlength));
//	free(contentlength);
//	
//	sendall(socketd, lsbuffer, lsbufferlen);
//	
//	free(lsbuffer);
	
	return 0;
	}
int Response(int socketd, struct RequestData * pRequestData, struct serverConf *serverconf){
     struct virtualserverConf *virtualserver;
     int returnval;
     char *sendbuf = NULL;
     size_t ServerNumber;
     char *protocol;
     char *code;
     char *word;
     
     if(pRequestData->protocol == NULL ||
        strcasecmp(pRequestData->protocol, "HTTP/1.0") == 0){
	if(pRequestData->host != NULL)
		ServerNumber = FindServer(serverconf, pRequestData->host);
	else	
     		ServerNumber = FindServer(serverconf, "all");
	if(ServerNumber == 0)
     		ServerNumber = FindServer(serverconf, "all");
	}
     else{//must be HTTP/1.1, we won't have anything to do with HTTP/0.9 here!
	if(pRequestData->host == NULL)
     		ServerNumber = FindServer(serverconf, "all");
	else 
		ServerNumber = FindServer(serverconf, pRequestData->host);
	if(ServerNumber == 0)
     		ServerNumber = FindServer(serverconf, "all");
	}
     	ServerNumber--;
    	 if(serverconf->hosts[ServerNumber].diralias == NULL)
		return HE_INTERNAL_SERVER_ERROR;
     
     	
     
     char *localrequest = NULL; //does this need to be null?
     cout << "File: " << pRequestData->url << endl;
     returnval = dealiaspath(&localrequest, serverconf->hosts[ServerNumber].diralias, pRequestData->url);
     if(returnval){
     	cout << "FATAL dealiaspath ERROR, CONFIGURATION(?) BASED!\n";
	return HE_INTERNAL_SERVER_ERROR;
	}
TRACE(localrequest);
     
     
     
     
     if(FileTest(localrequest)){
     	/*
     	TEST FOR CGI PROGRAMS HERE
     	*/
	
	if(isCgi(localrequest, serverconf->hosts[ServerNumber].cgipath)){
		returnval = RespondCgi(socketd, localrequest, pRequestData, serverconf, ServerNumber);
		if(returnval)
			return returnval;
		return 0;
		}
	
	else if(serverconf->hosts[ServerNumber].indexcgi != 0){
		char * filepnt = &(strrchr(localrequest, '/')[1]); 
		if(strcmp("index.cgi", filepnt) == 0){
			returnval = RespondCgi(socketd, localrequest, pRequestData, serverconf, ServerNumber);
			if(returnval)
				return returnval;
			return 0;
			}
		}
	
	
	
	returnval = RespondFile(socketd, localrequest, pRequestData, serverconf, ServerNumber);
	if(returnval)
		return returnval;
	}
     else if(DirTest(localrequest)){
	returnval = RespondDir(socketd, localrequest, pRequestData, serverconf, ServerNumber);
	if(returnval)
		return returnval;
	}
     else{
     	return HE_NOT_FOUND;
	}
     
     
     return 0;
     }    

 
